//Original:  Doug Lawson (dlawson@clark.net) 
//This script and many more are available free online at 
//The JavaScript Source!! http://javascript.internet.com 

var exp = new Date(); 

exp.setFullYear(exp.getFullYear() + 10);  //Cookie expire time

var calStartDOW = 1;  //define euro or us i.e. start week on mon or sun
var myDate = new Date(); //Used lots of places os make it a global
var myMonth; 		//Also make these persisent 
var myYear; 
var lastMonth;		
var lmYear; 
var nextMonth; 
var nmYear;

//Calculate bank holidays

//UK Holidays
//New Year's day = 1/1 or 1st weekday (Xmas + 7)
//Good friday = Easter-2, Easter Monday = Easter+1
//May Day = 1st Monday in May
//Spring bank = last Monday in May
//August bank = last Monday in August
//Xmas = 25/12 or next weekday after boxing
//Boxing day = 26/12 or next weekday
//Calculate 1yr plus month either side

var hols = new Array(11); 

function CalcHols() {
  var indx = 0;
  Easter(myYear, indx);
  indx = indx+2;
  Xmas(myYear, indx);
  indx = indx+3;
  Xmas(myYear-1, indx);
  indx = indx+3;
  BHol(myYear, indx);
}

function Easter(Y, indx) {     //Calculate easter and bank hols
  var C = Math.floor(Y/100);
  var N = Y - 19*Math.floor(Y/19);
  var K = Math.floor((C - 17)/25);
  var I = C - Math.floor(C/4) - Math.floor((C - K)/3) + 19*N + 15;
  I = I - 30*Math.floor((I/30));
  I = I - Math.floor(I/28)*(1 - Math.floor(I/28)*Math.floor(29/(I + 1))*Math.floor((21 - N)/11));
  var J = Y + Math.floor(Y/4) + I + 2 - C + Math.floor(C/4);
  J = J - 7*Math.floor(J/7);
  var L = I - J;
  var M = 3 + Math.floor((L + 40)/44);
  var D = L + 28 - 31*Math.floor(M/4);
  gfM = M -1;  //-1 to change months to 0-11
  gfD = D -2;  //Good friday
  if (gfD < 1) {
    gfD = gfD + yeardays[--gfM];
  }
  emM = M-1;
  emD = D + 1;  //Easter monday;
  if (emD > yeardays[emM]) {
    emD = emD - yeardays[emM++];
  }
  hols[indx] = Date.parse(gfD+" "+months[gfM]+" "+Y);   //Good friday
  hols[indx+1] = Date.parse(emD+" "+months[emM]+" "+Y);    //Easter Monday
}

function Xmas(Y, indx) {   //Calculate Xmas hols inc new year
  var xDate = new Date("25 Dec "+Y);  //Set Xmas
  switch (xDate.getDay()) {
    case 5 :  
      hols[indx]   = Date.parse("25 Dec "+Y);  //Xmas is friday
      hols[indx+1] = Date.parse("28 Dec "+Y);
      break;
    case 6 :  
      hols[indx]   = Date.parse("27 Dec "+Y); //Xmas is saturaday
      hols[indx+1] = Date.parse("28 Dec "+Y);
      break;
    case 0 : 
      hols[indx]   = Date.parse("26 Dec "+Y);  //Xmas is sunday 
      hols[indx+1] = Date.parse("27 Dec "+Y);
      break;
    default :
      hols[indx]   = Date.parse("25 Dec "+Y);    //Xmas is mon-thurs
      hols[indx+1] = Date.parse("26 Dec "+Y);
  }
  hols[indx+2] = hols[indx]+(7*24*60*60*1000);  //New year's day is 7 days later  
}

//May Day = 1st Monday in May
//Spring bank = last Monday in May
//August bank = last Monday in August

function BHol(Y, indx) {
  var bDate = new Date();  
  var D;
  bDate.setFullYear(Y, 4, 1);    //May is month 4!
  D =(8 - bDate.getDay())%7 +1;  //1st monday
  hols[indx] = Date.parse(D + " May "+Y);
  bDate.setFullYear(Y, 4, 31);  
  D =31-((6 + bDate.getDay())%7);  //last monday
  hols[indx+1] = Date.parse(D + " May "+Y);
  bDate.setFullYear(Y, 7, 31);  
  D =31-((6 + bDate.getDay())%7);  //last monday
  hols[indx+2] = Date.parse(D + " Aug "+Y);
}

/////////////////////////////////////////////////////////////////////////
//My Holidays
/////////////////////////////////////////////////////////////////////////

//SetCookie ("MyHols", "14 Apr 2003 +3;24 May 2003 +7;")

var myhols = new Array();

function CalcMyHols() {
  var MyHolList = GetCookie("MyHols");
  var i = 0;
  var ADMY;
  var j, k, m, n, cnt;
  var indx = 0;
  if (MyHolList == null)
     MyHolList ="";
  while ((j = MyHolList.indexOf(";",i))>0) {
    k = MyHolList.indexOf("+",i);
    cnt = MyHolList.slice(k+1,j);
    ADMY = new Date(MyHolList.slice(i,k));
    myhols[indx++] = Date.parse(ADMY.toString());
    for (n = 1; n < cnt; n++) {
      ADMY.setDate(ADMY.getDate()+1);
      myhols[indx++] = Date.parse(ADMY.toString());
    }
    i = j + 1;
  }
}



////////////////////////////////////////////////
// ABBREVIATED MONTH NAMES
// months[] is used internally for (among other things) compatibility with 
// javascript Date.parse() methods.  You should only have to change it if 
// your language variable changes. 
var months = new Array( "Jan","Feb","Mar", "Apr","May","Jun", "Jul","Aug","Sep","Oct", "Nov", "Dec");
///////////////////////////////////////////////
// Long month names 
// longmonths is used for calendar titles. They don't have to be long, 
// just whatever you would like to display 
// 
var longmonths = new Array( "January", "February", "March",
									 "April", "May", "June",
									 "July", "August", "September",
									 "October", "November", "December" ); 

var leapdays = new Array(31,29,31, 30,31,30, 31,31,30, 31,30,31); 
var yeardays = new Array(31,28,31, 30,31,30, 31,31,30, 31,30,31); 
//////////////////////////////////////////////// 
// the symbols to use at the top of the calendars
var dow = new Array("S","M","T","W","T","F","S"); 
// colors are done in style sheet

function isLeapYear( year ){
  // is it leap year ? returns a boolean
  return ( (0 == (year%4)) && ( (0 != (year%100)) || (0 == (year%400)))); 
  // ie, if the year divides by 4, but not by 100 except when it divides by
  // 400, it is leap year
} 
function isMyHoliday(year,mon,mday)
{ 
  // it the date on the list?
  var i;
  var D = Date.parse(mday + " " + months[mon] + " " + year)
  for (i=0; i< myhols.length; i++) {
    if ( D == myhols[i]) {
      return true;
    }
  }  
  return false; 
} 
function isHoliday(year,mon,mday)
{ 
  // it the date on the list?
  var i;
  var D = Date.parse(mday + " " + months[mon] + " " + year)
  for (i=0; i< hols.length; i++) {
    if ( D == hols[i]) {
      return true;
    }
  }  
  return false; 
} 
function isWeekend( year, mon, mday) 
{ 
  var mDate = new Date();
  mDate.setFullYear(year, mon, mday);
  return ( ( 0 == mDate.getDay())  ||  ( 6 == mDate.getDay()  )); 
} 
function drawCalendar(onclk, myYear, myMonth, sday, eday)
{ 
  // writes a calendar  for myMonth myYear. 
  // sday and eday are optional values indicating the range of dates 
  // to be set in bold. 
  // get a new date for the first day of the month the user is looking at
  var calDate = new Date( myYear,  myMonth, 1, 0,0,0,0 ); 
  // how many days are in the month ? 
  var mDays = isLeapYear(myYear) ? leapdays[myMonth]: yeardays[myMonth]; 
  var i = 0; 
  // what day of the week does the month start on? 
  var wkDay = calDate.getDay();
  var div1Class = "";  
  var div2Class = "";
  // if the function was called with the sday and eday arguments, then the 
  // caller wants a range of dates written in bold 
  var useBold = arguments.length >= 5 ? true: false; 
  // write the header for the calendar ( month and year ) 
  document.write("<CENTER>\n<TABLE onClick='"+onclk+"'BORDER='0' CELLPADDING='4' CELLSPACING='0' WIDTH=\"80%\">\n");
 document.write(
		"<TR><TD COLSPAN='5' class='mnhd'>", longmonths[myMonth],"</TD>",
		"<TD COLSPAN='2' class='yrhd'>", myYear,"</TD></TR>\n"
		); 
  // write the abbreviations for days of the week into the top line of the calendar
  document.write("<TR>"); 
  for(i=0; i< 7; i++) 
	 { document.write("<TD class='wkhd'>", dow[((i+calStartDOW)%7)],"</TD>");}
  document.write("</TR>\n");
  // start the first line with blank spaces until we get to the first day of the month
  document.write("<TR class='dt'>"); 
  for(i=0 ; i < ((7 - calStartDOW + wkDay)%7); i++) 
	 { document.write("<TD> &nbsp\; </TD>");	 }
  // since javascript doesn't do modulus on negative numbers, 
  // add 7 to anything that might be negative
  var cmdate = i - ((7 - calStartDOW + wkDay)%7); 
  // write the weekdays
  for( i=i; cmdate < mDays ; i++) 
	 {  
		// what is the date ? 
		cmdate++; 
	   // if we have reached the end of a week, start another one
		if(0 == (i%7)){ document.write("</TR>\n<TR class='dt'>"); } 
		//if its my holiday then set in myhol color
		if (isMyHoliday(myYear, myMonth,cmdate)) {
		  div1Class = "myhol";
		}else{
		  // if the date is a bank holiday, set it in bhol color
		  if(isHoliday(myYear, myMonth,cmdate)) {
		    div1Class = "bhol";
		  }else{
		    // if the date is a weekend, set it in hol color
		    if( isWeekend(myYear,myMonth,cmdate) ) {
		      div1Class = "hol";
		    }else{  
		      div1Class = "";
	          } 
		  }
		}
		// set today in bold
		if( ( useBold )  && (cmdate >= sday) && (cmdate <= eday))
		  { 	 div2Class = "tdy"; 
		}else{ 
			 div2Class = "";
 		  }	
		document.write("<TD class='", div1Class, "' ><DIV class='", div2Class, "'>",
                        cmdate, "</DIV></TD>");
	 }
  while(0 != (i%7)) { 	document.write("<TD>&nbsp\;</TD>"); i++; }
  document.write("</TR>"); 
  document.write("</TABLE></CENTER>\n"); 
} 

function newCalendars(myear, mmonth)
{ 
  // puts three calendars on the page from which it 
  // was called. (last month, this month, next month) 
  // Params
  // 
  // when called with 2 arguments
  // myear  -  the year for the center calendar
  // mmonth -  the month for the center calendar
  myMonth = parent.thisMonth; 
  myYear  = parent.thisYear; 
  if(arguments.length == 2) { myMonth = mmonth; myYear == myear; } 
  // it's surprising how many coders don't use modular arithmetic to 
  // do date and time. Javascript doesn't understand negative numbers in
  // positive modulus, so we add 11 instead of subtracting 1. 
  lastMonth = (myMonth + 11) % 12; 
  lmYear    = (myMonth == 0)? myYear -1: myYear; 
  nextMonth = (myMonth +1)%12; 
  nmYear    = (myMonth == 11)? myYear + 1: myYear;

  CalcHols();  //Calculate year's holidays
  CalcMyHols(); //Calculate my holidays

  // WRITE CALENDAR #1
  document.write("<TABLE BORDER=\"1\" ALIGN=\"CENTER\" WIDTH=\"95\%\"><TR VALIGN=\"TOP\"><TD>");
  var isthisMonth = ((lastMonth == myDate.getMonth())&& (lmYear==myDate.getFullYear())); 
  drawCalendar("bwdClick()", lmYear, lastMonth,
  					(isthisMonth ? myDate.getDate():0), 
					(isthisMonth ? myDate.getDate():0)); 
  isthisMonth = ((myMonth == myDate.getMonth())&& (myYear==myDate.getFullYear())); 
  document.write("</TD>\n<TD>");

  // WRITE CALENDAR #2
  drawCalendar("nowClick()", myYear, myMonth, 
					(isthisMonth? myDate.getDate():0), 
					(isthisMonth? myDate.getDate():0)); 
  document.write("</TD>\n<TD>");

  // WRITE CALENDAR #3
  isthisMonth = ((nextMonth == myDate.getMonth())&& (nmYear==myDate.getFullYear())); 
  drawCalendar("fwdClick()", nmYear, nextMonth,
					(isthisMonth ? myDate.getDate():0), 
					(isthisMonth ? myDate.getDate():0)); 
  document.write("</TD></TR></TABLE>\n");
} 

function bwdClick() {
  parent.thisMonth = lastMonth;
  parent.thisYear = lmYear;
  window.location = window.location;

}

function fwdClick() {
  parent.thisMonth = nextMonth;
  parent.thisYear = nmYear;
  window.location = window.location;

}

function nowClick() {
  parent.thisMonth = myDate.getMonth(); 
  parent.thisYear = myDate.getFullYear();
  window.location = window.location;

}


function GetCookie (name) {  
  var arg = name + "=";  
  var alen = arg.length;  
  var clen = document.cookie.length;  
  var i = 0;  
  while (i < clen) {    
    var j = i + alen;    
    if (document.cookie.substring(i, j) == arg)      
    return getCookieVal(j);    
    i = document.cookie.indexOf(" ", i) + 1;    
    if (i == 0) break;   
  }  
  return null;
}

function getCookieVal (offset) {  
  var endstr = document.cookie.indexOf (";", offset);  
  if (endstr == -1)    
  endstr = document.cookie.length;  
  return unescape(document.cookie.substring(offset, endstr));
}


function SetCookie (name, value) {  
  var argv = SetCookie.arguments;  
  var argc = SetCookie.arguments.length;  
  var expires = (argc > 2) ? argv[2] : null;  
  var path = (argc > 3) ? argv[3] : null;  
  var domain = (argc > 4) ? argv[4] : null;  
  var secure = (argc > 5) ? argv[5] : false;  
  document.cookie = name + "=" + escape (value) + 
  ((expires == null) ? "" : ("; expires=" + expires.toGMTString())) + 
  ((path == null) ? "" : ("; path=" + path)) +  
  ((domain == null) ? "" : ("; domain=" + domain)) +    
  ((secure == true) ? "; secure" : "");
}

//Edit holidays functions


//Edit functions
var ShowCnt;
var tabCnt;

function EditHols() {
  ShowCnt = 0;
  tabCnt = 3;  //1 and 2 are update and cancel buttons
  var MyHolList = GetCookie("MyHols");
  if (MyHolList == null)
     MyHolList ="";
  
  var i = 0;
  var ADMY;
  var j, k;
  var indx = 0;
   
  while ((j = MyHolList.indexOf(";",i))>0) {
    k = MyHolList.indexOf("+",i);
    NDays = MyHolList.slice(k+1,j);
    ADMY = new Date(MyHolList.slice(i,k));
    Adate = ADMY.getDate();
    Amnth = ADMY.getMonth()+1;
    Ayr = ADMY.getFullYear();
    ShowCnt++;
    PrintEditItem(ShowCnt);
    i = j + 1;
  }
  Adate = "";	//Add 3 blank entries
  Amnth ="";
  Ayr = "";
  NDays = "";
  for (i=1; i <= 3; i++) {
    ShowCnt++;
    PrintEditItem(ShowCnt);
  }
}

function PrintEditItem (Count) { 
  document.write('<tr><td>From :&nbsp;</td>',
     '<td><input type="text" size="2" name="Adate', Count, '" value="', Adate, '" tabindex="', tabCnt++,'" /></td>\n',
     '<td><input type="text" size="2" name="Amnth', Count, '" value="', Amnth, '" tabindex="', tabCnt++,'" /></td>\n',
     '<td><input type="text" size="4" name="Ayr', Count, '" value="', Ayr, '" tabindex="', tabCnt++,'" /></td>\n',
     '<td>&nbsp;for :&nbsp;</td>',
     '<td><input type="text" size="2" name="NDays', Count, '" value="', NDays, '" tabindex="', tabCnt++,'" /></td>\n',
     '</tr>\n');
}

function UpdateHols(form) {
  var i;
  var j = 0;
  var MyHolList = "";
  for (i=1; i<= ShowCnt; i++) {
    Adate = parseInt(eval('form.Adate'+i+'.value'));
    Amnth = parseInt(eval('form.Amnth'+i+'.value'));
    Ayr = parseInt(eval('form.Ayr'+i+'.value'));
    NDays = parseInt(eval('form.NDays'+i+'.value'));
    if (!(isNaN(Adate) || (Adate == 0) || isNaN(Amnth) || (Amnth == 0) ||
          isNaN(Ayr) || (Ayr == 0)   || isNaN(NDays) ||(NDays == 0) ) ) 
      MyHolList = MyHolList + Adate +" "+ months[Amnth-1] +" "+ Ayr +" +"+ NDays + ";";
  }
  SetCookie('MyHols', MyHolList, exp);
  parent.Calendar.location = parent.Calendar.location;
  window.location.href = "ToDo.htm";
}


